format binary as ""
use32
org	0x0
db	'MENUET01'
dd	1, START, I_END, mem, mem, 0, 0
; Current directory address string pointer
dd	cur_dir_path
; Common libs
include 'macros.inc'
include 'proc32.inc'
include 'dll.inc'
include 'box_lib.mac'
include 'load_lib.mac'
	@use_library	;use load lib macros
; Custom libs
include 'rxl_node.inc'
include 'rxl_attr.inc'
include 'rxl_read.inc'
include 'rxl_write.inc'
; XMPP libs
include 'login.asm'
include 'net.asm'
include 'common.asm'
include 'xmpp_attr.asm'
include 'xmpp_const.asm'
include 'xmpp_stream.asm'
include 'xmpp_xml.asm'
include 'debug.asm'


; Socket buffer size
SNDBUFFER	equ 4096
RCVBUFFER	equ 4096

; Network consts
STATUS_DISCONNECTED	= 0
STATUS_RESOLVING	= 1
STATUS_CONNECTING	= 2
STATUS_CONNECTED	= 3



;<<<<<<<<<<<<<<<<<<<
;
;       CODE BLOCK
;
;<<<<<<<<<<<<<<<<<<<

START:
	stdcall dll.Load, @IMPORT
	; universal load library/librarys
	sys_load_library  library_name, cur_dir_path, library_path, system_path, err_message_found_lib, head_f_l, edit_box_import, err_message_import, head_f_i
	;if return code =-1 then exit, else nornary work
	cmp	eax,-1
	jz	close_progr

	mcall	40,0x27
	call	login_win_draw

wait_login:
	; Wait for action
	mcall	10
	; Check if need to redraw
	dec	eax
	jz	login_win_redraw
	; Key in buffer
	dec	eax
	jz	login_key
	; Check if any button was pressed
	dec	eax
	jz	login_btn_action
	; Check login box
	push	dword login_box
	call	[edit_box_mouse]
	; Check password box
	push	dword pass_box
	call	[edit_box_mouse]
	; Check server box
	push	dword serv_box
	call	[edit_box_mouse]
	; Check DEBUG BOX
	push	dword dbg_box
	call	[edit_box_mouse]
	; Get network event
	call	network_event
	; If nothing happened
	jmp	wait_login

get_sys_colours:
	; Push all regs to stack saving them
	pusha
	; fn 48 - sys colours
	mov	eax, 48
	; fn 48.ebx - get
	mov	ebx, 3
	; fn 48.3.ecx - pointer to var sys_colours
	mov	ecx, sys_colours
	; fn 48.3.edx - return 40 bytes
	mov	edx, 10*4
	mcall
	; Pop all regs
	popa
	; Return
	ret

; Button was pressed
login_btn_action:
	; Get button number
	mcall	17
	; If id = 1 (red cross) - close program
	cmp	ah, 1
	je	close_progr
	; If id = 2 - login button
	cmp	ah, 2
	je	login_submit
	; Wait for next input
	jmp	wait_login

; Redraw action
login_win_redraw:
	call	login_win_draw
	jmp	wait_login

; Key was pressed
login_key:
	; Recieve pressed key into eax
	mcall	2
	; Add value into loginbox if it was editbox key
	push	dword login_box
	call	[edit_box_key]
	; Add value into passbox if it was editbox key
	push	dword pass_box
	call	[edit_box_key]
	; Add value into servbox if it was editbox key
	push	dword serv_box
	call	[edit_box_key]
	; DEBUG
	push	dword dbg_box
	call	[edit_box_key]
	; Wait for next input
	jmp	wait_login

; Login action
login_submit:
	construct_stream	x_stream,login_text,serv_text
	pushStreamStruc 	x_stream
	stdcall 		strcpy,xc_xml_start,snd_buffer
	createXmlOpen		xc_stream,xc_stream,edi
dns_res:
; RESOLVE DNS
	stdcall resolve_dns,x_stream.to
	test	eax,eax 	; Test for error
	jnz	wait_login	; Jump if error

; GET IP AND PORT
	stdcall convert_IP_dec,ebx  ; If no error - get decimal IP
	mov	[sockaddr1.port], 0x6614
; OPEN SOCKET
	call open_socket
send_login:
	stdcall strlen,snd_buffer
	mov	[msg_len], ecx
	mcall	send, [socketnum], snd_buffer, [msg_len], 0
	jmp wait_login





network_event:
	mov	eax, [status]
	dec	eax
	; STATUS_DISCONNECTED
	js	.nothing
	; STATUS_RESOLVING
	jz	.nothing
	; STATUS_CONNECTING
	dec	eax
	jz	.nothing
	; STATUS_CONNECTED
	jmp	.connected

 .nothing:
	ret

 .connecting:

 .connected:
	call	socket_recieve
	ret


socket_recieve:
	mcall	recv, [socketnum], rcv_buffer, RCVBUFFER, MSG_DONTWAIT
;tls_begin:
;        push    0
;        push    xc_starttls_ns
;        push    xc_ns
;        createXmlOpen   xc_starttls,'',snd_buffer
;        createXmlClose  xc_starttls,'',eax
;        stdcall strlen,snd_buffer
;        mov     [msg_len],ecx
;tls_send:
;        mcall   send,[socketnum],snd_buffer,[msg_len],0



;new_stream:
;        construct_stream        x_stream,login_text,serv_text
;        pushStreamStruc         x_stream
;        stdcall                 strcpy,xc_xml_start,snd_buffer
;        createXmlOpen           xc_stream,xc_stream,edi
;        stdcall strlen,snd_buffer
;        mov     [msg_len],ecx
;new_stream_send:
;        mcall   send,[socketnum],snd_buffer,[msg_len],0



auth:
	push	0
	push	xc_auth_plain
	push	xc_auth_mech
	push	xc_auth_sasl
	push	xc_ns
	createXmlOpen	xc_auth,'',snd_buffer
	stdcall strlen,test_auth
	stdcall base64_encode,test_auth,ecx,eax
	stdcall strlen,snd_buffer
	add	ecx,snd_buffer
	createXmlClose	xc_auth,'',ecx
	stdcall strlen,snd_buffer
	mov	[msg_len], ecx
send_auth:
	mcall	send, [socketnum], snd_buffer, [msg_len], 0
	jmp	wait_login

free_alloc_memory:
	push	esi
	call	[freeaddrinfo]
	ret


close_progr:
	mcall	-1


;<<<<<<<<<<<<<<<<<<<
;
;       DATA BLOCK
;
;<<<<<<<<<<<<<<<<<<<
x_stream	xmpp_stream

; Path where additional box_lib library is stored
system_path	db '/rd/1/lib/box_lib.obj', 0
library_name	db 'box_lib.obj'

; Sys colours table
sys_colours:
	w_frames		dd ?
	w_grab			dd ?
	w_grab_button		dd ?
	w_grab_button_text	dd ?
	w_grab_text		dd ?
	w_work			dd ?
	w_work_button		dd ?
	w_work_button_text	dd ?
	w_work_text		dd ?
	w_work_graph		dd ?

; Function import pointer
edit_box_import:
	edit_box_draw		dd aEdit_box_draw
	edit_box_key		dd aEdit_box_key
	edit_box_mouse		dd aEdit_box_mouse
	version_ed		dd aVersion_ed
				dd 0
				dd 0
	aEdit_box_draw		db 'edit_box',0
	aEdit_box_key		db 'edit_box_key',0
	aEdit_box_mouse 	db 'edit_box_mouse',0
	aVersion_ed		db 'version_ed',0

; Current dir path string buffer
cur_dir_path	rb 4096
; Library dir path string buffer
library_path	rb 4096

; Common error messages if library can't be imported or loaded
err_message_found_lib	db 'Sorry I cannot load library box_lib.obj',0
head_f_i:
head_f_l		db 'System error',0
err_message_import	db 'Error on load import library box_lib.obj',0



;<<<<<<<<<<<<<<<<<<<<<<<<<<
test_auth	db '\0test\0test',0
;<<<<<<<<<<<<<<<<<<<<<<<<<<



;<<<<<<<<<<<<<<<<<<<<<<<<
; NETWORK
;<<<<<<<<<<<<<<<<<<<<<<<<
sockaddr1:
	dw	AF_INET4
	.port	dw 0
	.ip	dd 0
	rb	10		; Address buffer

ip_ptr		dd ?
socketnum	dd ?
status	    dd STATUS_DISCONNECTED


align 4
@IMPORT:

library network, 'network.obj'
import	network, \
	getaddrinfo,	'getaddrinfo',\
	freeaddrinfo,	'freeaddrinfo',\
	inet_ntoa,	 'inet_ntoa'


; End of program
I_END:
; Recieve buffer
msg_len 	dd 0
snd_buffer	rb SNDBUFFER
rcv_buffer	rb RCVBUFFER
tmp_buffer	rb 1024
; Additional buffer
		rb 2048
mem:
