; Strlen by Heavyiron
proc strlen lpStr
	mov	ecx,[lpStr]
	dec	ecx
@@:
	inc	ecx
	cmp	byte [ecx], 0
	jne	@b
	sub	ecx, [lpStr]
	ret
endp

; Strcpy
; Copies string and returns the [last byte+1] address as edi
proc strcpy lpSrc,lpDst:DWORD
	ccall	strlen,[lpSrc]
	mov	esi, [lpSrc]
	mov	edi, [lpDst]
	cld
	rep	movsb
	ret
endp

proc clrbuf dBuf,len
	mov	edi, [dBuf]
	mov	ecx, len
@@:
	mov	byte[edi],0
	inc	edi
	dec	ecx
	jnz	@b
	ret
endp

; Base64 encoder
; Encodes given buffer into base64 stream
; Returns also output size in eax
; Written by decard, http://decard.net/download/base64.zip
base64_table db 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/',0

proc base64_encode, .source,.src_size,.out_buf
	push	ecx edx esi edi
	mov	esi,[.source]
	mov	edi,[.out_buf]
	mov	ecx,[.src_size]
     .loop:
	mov	edx,[esi]
	cmp	ecx,3
	jae	.remainder_ok
	and	edx,0xffff
	cmp	ecx,2
	jae	.remainder_ok
	and	edx,0xff
     .remainder_ok:
	bswap	edx

	mov	eax,edx
	shr	eax,26
	and	eax,111111b
	mov	al,[base64_table+eax]
	mov	[edi],al
	inc	edi

	mov	eax,edx
	shr	eax,20
	and	eax,111111b
	mov	al,[base64_table+eax]
	mov	[edi],al
	inc	edi
	dec	ecx
	jz	.r2

	mov	eax,edx
	shr	eax,14
	and	eax,111111b
	mov	al,[base64_table+eax]
	mov	[edi],al
	inc	edi
	dec	ecx
	jz	.r1

	mov	eax,edx
	shr	eax,8
	and	eax,111111b
	mov	al,[base64_table+eax]
	mov	[edi],al
	inc	edi

	add	esi,3
	dec	ecx
	jnz	.loop
	jmp	.finish
     .r2:
	mov	byte[edi],'='
	inc	edi
     .r1:
	mov	byte[edi],'='
	inc	edi
     .finish:
	mov	byte[edi],0
	sub	edi,[.out_buf]
	mov	eax,edi
	pop	edi esi edx ecx
	ret
endp