macro createXmlOpen name,type,buffer {
; Usage:
;       Name - xml node name
;       Type - node type, e.g. <name:type args>
;       Buffer - xml string buffer
;       Parameters should be pushed into stack in the order
;        0,data,label,data,label...
;        Last par should be 0
; Output:
;       In buffer - xml string
;       In eax - last byte

	lea	eax,[buffer]
; Add opening
	mov	DWORD[eax],'<'
	inc	eax
; Write node name
	stdcall strcpy,name,eax
	stdcall strlen,name
	add	eax, ecx
; Check if node type is present
	stdcall strlen,type
	cmp	ecx, 0
	jz	@f
; If type is present
	mov	DWORD[eax], ':'
	inc	eax
	stdcall strcpy,type,eax
	stdcall strlen,type ; Ok, it should already be in eax, but just in case
	add	eax, ecx
@@:
; Add parameter name
	pop	ebx
	cmp	DWORD[ebx],0
	jz	@f
	mov	DWORD[eax], ' '
	inc	eax
	stdcall strcpy,ebx,eax
	stdcall strlen,ebx
	add	eax,ecx
; Add parameter value
	mov	DWORD[eax], '='
	inc	eax
	mov	DWORD[eax], 39
	inc	eax
	pop	ebx
	stdcall strcpy,ebx,eax
	stdcall strlen,ebx
	add	eax,ecx
	mov	DWORD[eax], 39
	inc	eax
	jmp	@b
@@:
; Add closing
	mov	DWORD[eax], '>'
	inc	eax
	mov	DWORD[eax], 0
}


macro createXmlClose name,type,buffer {
; Usage:
;       Name - xml node name
;       Type - node type, e.g. <name:type args>
;       Buffer - xml string buffer
	 lea	 eax,[buffer]
; Add opening
	mov	DWORD[eax],'<'
	inc	eax
	mov	DWORD[eax],'/'
	inc	eax
; Write node name
	stdcall strcpy,name,eax
	stdcall strlen,name
	add	eax, ecx
; Check if node type is present
	stdcall strlen,type
	cmp	ecx, 0
	jz	@f
; If type is present
	mov	DWORD[eax], ':'
	inc	eax
	stdcall strcpy,type,eax
	stdcall strlen,type ; Ok, it should already be in eax, but just in case
	add	eax, ecx
@@:
; Add closing
	mov	DWORD[eax],'>'
	inc	eax
	mov	DWORD[eax],0
}